function [zdot] = dpendd(time,z)
// This function computes the state derivatives for the computation
// of the state for the next sampling time

	// Code By: Ambarish Goswami
	// INRIA Rhone-Alpes, Grenoble, France
	// Copyright: 1994, 1995, 1996

	stiffness = 0.00;			// setting hip joint stiffness
	damping = 0.00;			// setting hip joint damping
  	th_n = z(1);
	th_s = z(2);
	thd_n = z(3);
	thd_s= z(4);
   	slr = sin(th_n - th_s); 
	clr = cos(th_n - th_s);
	sl = sin(th_n);
	sr = sin(th_s);
	cl = cos(th_n);
	cr = cos(th_s);
			//inertia matrix
   	inertia = [m*b^2  -m*l*b*clr;-m*l*b*clr  mk*l^2+m*a^2]; 
			// centrifugal + gravity
   	vec = -[(-m*l*b*slr*thd_s^2)+(m*b*sl*g); 		
	(m*l*b*slr*thd_n^2)-(mh*l+m*a+m*l)*sr*g];	
			// damping torque in the hip joint
			// Just an example
//	fact = -((thd_n - thd_s)^2*damping)*sign(thd_n - thd_s);
			// to add the extra damping torque to the generalized torques
	vec = vec + fact*[1 -1]'; 
			// acceleration for the next sampling
   	res = inv(inertia)*vec; 	
   	thdd_n = res(1);
	thdd_s = res(2);
			// state derivatives for next sampling
   	zdot = [thd_n;thd_s;thdd_n;thdd_s];	
