function [ke, pe, pe1] = energy_vector(z, ytipt, kk)
//calculation of kinetic energy  and potential energy at any instant

	// Code By: Ambarish Goswami
	// INRIA Rhone-Alpes, Grenoble, France
	// Copyright: 1994, 1995, 1996

	d = size(z);
	for i = 1 : d(2);
		if kk < 0 then
			inert = [m*b^2  -m*l*b*cos(z(1,i)-z(2,i));...
				-m*l*b*cos(z(1,i)-z(2,i)) mk*l^2+m*a^2];
			velocity = [z(3,i); z(4,i)];
		else 
			inert = [mk*l^2+m*a^2  -m*l*b*cos(z(1,i)-z(2,i));...
				-m*l*b*cos(z(1,i)-z(2,i)) m*b^2 ];
			velocity = [z(4,i); z(3,i)];
			[z(1,i); z(2,i)] = [0 1; 1 0]*[z(2,i); z(1,i)];
		end;

				// KE
		ke(i) = 0.5*velocity'*inert*velocity;
				// global PE
		pe(i) = mh*g*(ytipt+l*cos(z(2,i))) + m*g*(ytipt+a*cos(z(2,i))) +...
			 m*g*(ytipt+(l*cos(z(2,i)) - b*cos(z(1,i))));

				// local PE
		pe1(i) = mh*g*(l*cos(z(2,i))) + m*g*(a*cos(z(2,i))) +...
			m*g*((l*cos(z(2,i)) - b*cos(z(1,i))));
	end;



