function [h] = transition(alpha)
	// see calculations in any of our papers
	// Calculates the transition matrix

	// Code By: Ambarish Goswami
	// INRIA Rhone-Alpes, Grenoble, France
	// Copyright: 1994, 1995, 1996
	
	ar_m1 = mh * l^2 + 2 * m * a * l;
	br_m = -m * a * b;
	ah_m = -m * a * b;
	bh_m = 0;

	k1 = - m * b * l * cos(2 * alpha);
	ar_m = ar_m1 * cos(2 * alpha) - m * a * b;

	ar_p = m * b^2 + k1;
	br_p = m * l^2 + m * a^2 + mh * l^2 + k1;
	ah_p = m * b^2;
	bh_p = k1;

	p = [ar_m  br_m ; ah_m  bh_m];
	q = [ar_p  br_p ; ah_p  bh_p];

	h = inv(q) * p;
//	reorganized to  change the support and non-support variables (because
//	the theoretical calculations were done the other way
	h = [h(2,2) h(2,1); h(1,2) h(1,1)];
