clear 
clf

%% This program creates the Figure 3&4 in the compass gait IJRR journal paper
% Studies the effect of the mapping by the transition matrix of the
% compass gait robot.

d2r = pi/180; r2d = 180/pi;

%for i2 = 0.3 : 1 : 10
mu =  2;
beta = 1;
m = 5; mh = mu * m; a = 0.5; b = beta * a; l = a + b; j = [0 1;1 0];

%z0 = [n-s_angle; s_angle; n-s vel; s_vel]

ar_m1 = mh * l^2 + 2 * m * a * l; br_m = -m * a * b;
ah_m = -m * a * b; bh_m = 0; ah_p = m * b^2;


ran1 = -100: 200: 100;
ran2 = 40;
[i1, i2] = meshgrid(ran1, ran1);	%i1 = thd_ns_min, i2 = thd_s_min
thd_ns_min =  i1*d2r;
thd_s_min =  i2*d2r;
clear i1 i2 ran1
j = 0;

al1 = 2*40;
vector4 = [100 -100 0; 100 100 0; -100 100 0; -100 -100 0; 100 -100 0;...
 100 -100 al1; 100 100 al1; -100 100 al1; -100 -100 al1; 100 -100 al1;...
 100 100 al1; 100 100 0; -100 100 0; -100 100 al1; -100 -100 al1; -100 -100 00];

for i = 1 : 1 : max(size(vector4))-1
	line([vector4(i,1); vector4(i+1,1)],...
		[vector4(i,2); vector4(i+1,2)],...
		[vector4(i,3); vector4(i+1,3)]);
	hold on
end		% for i

i = 1;
for i3 = 0 : 2 : ran2			% alpha
	alpha 		= i3*d2r;

	k1 = - m * b * l * cos(2 * alpha);
	ar_m = ar_m1 * cos(2 * alpha) - m * a * b;

	ar_p = m * b^2 + k1;
	br_p = m * l^2 + m * a^2 + mh * l^2 + k1;
	bh_p = k1;

	p = [ar_m  br_m ; ah_m  bh_m];
	q = [ar_p  br_p ; ah_p  bh_p];

	h = inv(q) * p;

	thd_ns_pl = (h(1,1)*thd_ns_min + h(1,2)*thd_s_min)*r2d;
	thd_s_pl = (h(2,1)*thd_ns_min + h(2,2)*thd_s_min)*r2d;

	if i > 1
line([vv1(1,1); thd_ns_pl(1,1)],[vv2(1,1); thd_s_pl(1,1)],[al_x; 2*alpha*r2d]);
hold on
line([vv1(1,2); thd_ns_pl(1,2)],[vv2(1,2); thd_s_pl(1,2)],[al_x; 2*alpha*r2d]);
hold on
line([vv1(2,1); thd_ns_pl(2,1)],[vv2(2,1); thd_s_pl(2,1)],[al_x; 2*alpha*r2d]);
hold on
line([vv1(2,2); thd_ns_pl(2,2)],[vv2(2,2); thd_s_pl(2,2)],[al_x; 2*alpha*r2d]);
hold on
	end 		%  if


	al1 = 2*alpha*r2d;
	al = 2*alpha*ones(size(thd_ns_min))*r2d;
%	pcolor(thd_ns_pl, thd_s_pl,al);
	colormap(bone)
	surf(thd_ns_pl, thd_s_pl,al);
	hold on
	grid

	vv1 = thd_ns_pl;
	vv2 = thd_s_pl;
	al_x = 2*alpha*r2d;
	i = i + 1;

end							% i3

%	reorganized to  change the support and non-support variables (because
%	the theoretical calculations were done the other way
%	h = [h(2,2) h(2,1); h(1,2) h(1,1)];



%xlabel('theta_d_ns (deg/sec)');
%ylabel('theta_d_s (deg/sec)');
%zlabel('interleg angle (deg)');
axis equal
view(40,30)
print 'epsfigs_tmp/contraction' -deps

break







%%%%%%%  Connect with the top part%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%






plot3(vector2(:,1), vector2(:,2), vector2(:,3),'y.')
hold on
plot3(vector3(:,1), vector3(:,2), vector3(:,3))
view(30,20)
grid
xlabel('theta_d_ns (degree/sec)');
ylabel('theta_d_s (degree/sec)');
zlabel('interleg angle (degree)');
axis equal
print 'epsfigs_tmp/contraction' -depsc

break

plot3(vector1(:,1), vector1(:,2), vector1(:,3),'c.')
hold on

for i = 1 : 1 : max(size(vector4))-1
	line([vector4(i,1); vector4(i+1,1)],...
		[vector4(i,2); vector4(i+1,2)],...
		[vector4(i,3); vector4(i+1,3)]);
	hold on
end

for i = 1 : 1 : max(size(vector1))
	line([vector1(i,1);vector1(i,1)],...
		[vector1(i,2);vector1(i,2)],...
		[vector1(i,3);vector1(i,3)]);
	hold on
end

for i = 1 : 1 : max(size(vector2))
	line([vector2(i,1);vector2(i,1)],...
		[vector2(i,2);vector2(i,2)],...
		[vector2(i,3);vector2(i,3)]);
	hold on
end
grid
view(30,10)
xlabel('non-support leg velocity (degree/sec)');
ylabel('support leg velocity (degree/sec)');
zlabel('interleg angle (degree)');
axis equal

%print 'epsfigs_tmp/contraction' -deps

break

