
clear 
clf

%% This program creates the Figure 4 in the compass gait IJRR journal paper
% Studies the effect of the mapping by the transition matrix of the
% compass gait robot.

d2r = pi/180; r2d = 180/pi;
for i2 = 0.3 : 1 : 10
	mu =  i2;
	beta = 1;
	m = 5; mh = mu * m; a = 0.5; b = beta * a; l = a + b; j = [0 1;1 0];

	ar_m1 = mh * l^2 + 2 * m * a * l; br_m = -m * a * b;
	ah_m = -m * a * b; bh_m = 0; ah_p = m * b^2;

	ran2 = 40;
	i = 0;
	ang = (0 : .1 : 40)*2;
	for i3 = 0 : 1 : 40			% alpha
		i = i + 1;
		alpha 		= i3*d2r;

		k1 = - m * b * l * cos(2 * alpha);
		ar_m = ar_m1 * cos(2 * alpha) - m * a * b;

		ar_p = m * b^2 + k1;
		br_p = m * l^2 + m * a^2 + mh * l^2 + k1;
		bh_p = k1;

		p = [ar_m  br_m ; ah_m  bh_m];
		q = [ar_p  br_p ; ah_p  bh_p];

		h = inv(q) * p;
		x = eig(h);
		val(1,i) = x(1);
		val(2,i) = x(2);

	end

plot(val(1,:))
hold on
plot(val(2,:),'--')


end
break

xlabel('interleg angle (deg)');
ylabel('normalized length "beta"');
zlabel('eigenvalue modulus');
